unit U_DJBCKOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit,
  RM_BarCode, cxLookAndFeels, cxLookAndFeelPainters, cxNavigator;

type
  TfrmDJBCKOutList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column19: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    SPID: TEdit;
    SPSpec: TEdit;
    CRType: TComboBox;
    SPCF: TEdit;
    QCorderNo: TEdit;
    Label10: TLabel;
    CKorderNo: TEdit;
    Label11: TLabel;
    FromFactoryName: TEdit;
    Label13: TLabel;
    ToFactoryName: TEdit;
    Label9: TLabel;
    Label14: TLabel;
    RCGangNo: TEdit;
    GangNo: TEdit;
    v1Column15: TcxGridDBColumn;
    v1Column20: TcxGridDBColumn;
    ToolButton3: TToolButton;
    ADOQueryPrint: TADOQuery;
    v1Column21: TcxGridDBColumn;
    Label15: TLabel;
    PRTColor: TEdit;
    Label16: TLabel;
    SOrddefstr1: TEdit;
    Label17: TLabel;
    PRTHX: TEdit;
    RM1: TRMGridReport;
    RMBarCodeObject1: TRMBarCodeObject;
    v1Column22: TcxGridDBColumn;
    v1Column23: TcxGridDBColumn;
    v1Column24: TcxGridDBColumn;
    Label18: TLabel;
    CustomerNoName: TEdit;
    N3: TMenuItem;
    ToolButton1: TToolButton;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure SPIDKeyPress(Sender: TObject; var Key: Char);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure N3Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    canshu1, canshu2: string;
    procedure InitGrid();
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDJBCKOutList: TfrmDJBCKOutList;

implementation

uses
  U_DataLink, U_RTFun, U_Fun, U_DJBCKOutPut;

{$R *.dfm}

procedure TfrmDJBCKOutList.FormDestroy(Sender: TObject);
begin
  frmDJBCKOutList := nil;
end;

procedure TfrmDJBCKOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmDJBCKOutList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 30;
end;

procedure TfrmDJBCKOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.*  ');
      sql.Add(' from CK_SXPB_CR A');
      sql.add(' where A.CRTime>=' + quotedstr(Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime))) + ' and A.CRTime<' + quotedstr(Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1))));
      SQL.Add(' and CRFlag=''出库''  ');
      SQL.Add(' and isnull(CKName,'''')=''待检布'' ');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmDJBCKOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmDJBCKOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmDJBCKOutList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('外加工出库列表PMD', Tv1, '外加工仓库');
  Close;
end;

procedure TfrmDJBCKOutList.FormShow(Sender: TObject);
begin
  if Trim(canshu2) = '查看' then
  begin
    TBAdd.Visible := False;
    TBDel.Visible := False;
    TBEdit.Visible := False;
  end
  else
  begin
    TBAdd.Visible := True;
    TBDel.Visible := True;
    TBEdit.Visible := True;
  end;
  ReadCxGrid('外加工出库列表PMD', Tv1, '外加工仓库');
  //InitGrid();
end;

procedure TfrmDJBCKOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('外加工出库列表', cxGrid2);
end;

procedure TfrmDJBCKOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmDJBCKOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmDJBCKOutList.SPIDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    {if Length(Trim(SPID.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        sql.Add(' from CK_SXPB_CR A');
        sql.add(' where SPID like :SXID');
        Parameters.ParamByName('SXID').Value:='%'+Trim(SXID.Text)+'%';
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end; }
  end;
end;

procedure TfrmDJBCKOutList.N1Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not eof do
    begin
      if Trim(CDS_Main.fieldbyname('CRType').AsString) = '检验出库' then
      begin
        Edit;
        FieldByName('SSel').Value := True;
        Post;
      end;
      Next;
    end;
  end;
  CDS_Main.EnableControls;
end;

procedure TfrmDJBCKOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmDJBCKOutList.TBDelClick(Sender: TObject);
var
  strsql: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('已检验不能删除数据!', '提示', 0);
    Exit;
  end;
  if Application.MessageBox('确定要删除选择的数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select Top 1 * from WFB_MJJY where isnull(APID,'''')=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.IsEmpty = False then
        begin
          Application.MessageBox('已检验不能删除数据!', '提示', 0);
          Exit;
        end;
        if Trim(CDS_Main.fieldbyname('CRType').AsString) = '加工出库' then
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where FZSPID=');
            sql.Add('(select SPID from CK_SXPB_CR where PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            sql.Add(' and isnull(CRType,'''')=''平移入库'')');
            sql.Add(' and CRQtyFlag=-1');
            Open;
          end;
          if ADOQueryTemp.IsEmpty = False then
          begin
            Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
            Exit;
          end;
        end;
        strsql := '来自记录：' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + ';当前记录:' + Trim(CDS_Main.fieldbyname('SPID').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          sql.Add(' Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + '''');
          if Trim(CDS_Main.fieldbyname('CRType').AsString) = '加工出库' then
          begin
            sql.Add(' delete CK_SXPB_CR where CRType=''平移入库''  and  PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          end;
          sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
          sql.Add(' ' + quotedstr(trim(DName)));
          sql.Add(',getdate() ');
          sql.Add(',' + quotedstr(trim(self.Caption)));
          sql.Add(',' + quotedstr(trim('删除待检布出库')));
          sql.Add(',' + quotedstr(trim(strsql)));
          sql.Add(',' + quotedstr(trim('成功')));
          sql.Add(')');
          ExecSQL;

        end;
      end;
      CDS_Main.Delete;
    end;
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('删除异常!', '提示', 0);
  end;
end;

procedure TfrmDJBCKOutList.TBAddClick(Sender: TObject);
begin
  try
    frmDJBCKOutPut := TfrmDJBCKOutPut.Create(Application);
    with frmDJBCKOutPut do
    begin
      FBCId := '';
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDJBCKOutPut.Free;
  end;
end;

procedure TfrmDJBCKOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CK_SXPB_CR where FZSPID=');
    sql.Add('(select SPID from CK_SXPB_CR where PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
    sql.Add(' and isnull(CRType,'''')=''平移入库'')');
    sql.Add(' and CRQtyFlag=-1');
    Open;
  end;
  if ADOQueryTemp.IsEmpty = False then
  begin
    Application.MessageBox('已有出库记录，不能修改!', '提示', 0);
    Exit;
  end;
  try
    frmDJBCKOutPut := TfrmDJBCKOutPut.Create(Application);
    with frmDJBCKOutPut do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDJBCKOutPut.Free;
  end;

end;

procedure TfrmDJBCKOutList.ToolButton3Click(Sender: TObject);
var
  fPrintFile: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
begin
  if CDS_Main.IsEmpty then
    Exit;
  //if Trim(CDS_Main.fieldbyname('CRType').AsString)<>'检验出库' then Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签.rmf';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      with ADOQueryPrint do
      begin
        Close;
        sql.Clear;
        sql.Add(' select A.* ,B.SOrddefstr1,B.PRTColor,B.PRTHX,C.OrderNo,C.MPRTCodeName');
        sql.Add(',C.CustomerNoName,C.ConNo');
        sql.Add(',khCode=(select zdyNameZ from KH_Zdy_Attachment X where X.zdyname=C.CustomerNoName and X.Type=''KHName'') ');
        sql.Add(',khConNo=(select top 1 khConNo from JYOrderCon_Main X where X.ConNO=C.conNO) ');
        sql.Add(' from CK_SXPB_CR A');
        sql.Add(' left join JYOrder_Sub B on A.ORDSubIdCK=B.SubId');
        sql.Add(' left join JYOrder_Main C on A.ORDMainIdCK=C.MainId');

        sql.Add(' where A.SPId=''' + Trim(CDS_Main.fieldbyname('SPId').AsString) + '''');
        Open;
      end;
      SCreateCDS20(ADOQueryPrint, CDS_PRT);
      SInitCDSData20(ADOQueryPrint, CDS_PRT);

      try
        Moudle := LoadLibrary('MakeQRBarcode.dll');
        @Makebar := GetProcAddress(Moudle, 'Make');
        @Mixtext := GetProcAddress(Moudle, 'MixText');
        Txt := Trim(CDS_PRT.fieldbyname('SPID').AsString);
        fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
        if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
        if FileExists(fImagePath) then
          DeleteFile(fImagePath);
        Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
      except
        CDS_Main.EnableControls;
        application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
        exit;
      end;

      if FileExists(fPrintFile) then
      begin
        RMVariables['QRBARCODE'] := fImagePath;
        RM1.LoadFromFile(fPrintFile);
        //RM1.ShowReport;
        RM1.PrintReport;
      end
      else
      begin
        CDS_Main.EnableControls;
        Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签.rmf'), '提示', 0);
        Exit;
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

end;

procedure TfrmDJBCKOutList.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  if CDS_Main.IsEmpty then Exit;
//  if Trim(CDS_Main.fieldbyname('CRType').AsString)<>'检验出库' then
//  begin
//    Tv1.OptionsSelection.CellSelect:=False;
//  end else
//  begin
//    Tv1.OptionsSelection.CellSelect:=True;
//  end;
end;

procedure TfrmDJBCKOutList.N3Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not eof do
    begin
      Edit;
      FieldByName('SSel').Value := True;
      Post;
      Next;
    end;
  end;
  CDS_Main.EnableControls;
end;

procedure TfrmDJBCKOutList.ToolButton1Click(Sender: TObject);
var
  fPrintFile: string;
var
  WSql: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签A4.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf';
  WSql := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if WSql <> '' then
        WSql := WSql + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString))
      else
        WSql := 'where A.SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;
  WSql := WSql + ')';
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.*,D.*  ');
    sql.Add(',KHConno=(select KHConno from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
    sql.Add(',MPRTBZNote=(select MPRTBZNote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
    sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
    sql.Add(',PRTOrderQty=(select PRTOrderQty from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
    sql.Add(' from CK_SXPB_CR A');
    sql.Add(' left join TP_File D on D.TFID=A.SPID ');
    sql.Add(WSql);
//    ShowMessage(SQL.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryPrint, CDS_PRT);
  SInitCDSData20(ADOQueryPrint, CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.ShowReport;
//    RM1.PrintReport;
  end
  else
  begin
    CDS_Main.EnableControls;
    Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf'), '提示', 0);
    Exit;
  end;
end;

end.

